Page MenuHomeFreeBSD

powerpc/spe: Implement SPE exception handling
ClosedPublic

Authored by jhibbits on Oct 6 2018, 12:37 AM.

Details

Summary

The Signal Processing Engine (SPE) found in Freescale e500 cores (and
others) offloads IEEE-754 compliance (NaN, Inf handling, overflow,
underflow) to software, most likely as a means of simplifying the APU
silicon. Some software, like AbiWord, needs full IEEE-754 compliance,
including NaN handling. Implement the necessary bits to enable it.

Test Plan

Tested on a P1022, both a simple floating point program and polkitd.
polkitd uses spidermonkey, and is a great test for FPU conformance.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

jhibbits created this revision.Oct 6 2018, 12:37 AM

Aside from one inline note, this looks OK for non-SPE.

sys/powerpc/booke/spe.c
126 ↗(On Diff #48817)

Doesn't this break on non-SPE systems?

jhibbits marked 2 inline comments as done.Oct 11 2018, 8:28 PM
jhibbits added inline comments.
sys/powerpc/booke/spe.c
126 ↗(On Diff #48817)

spe.c is only built for powerpcspe, so no :)

jhibbits marked an inline comment as done.Oct 11 2018, 8:29 PM
This revision was not accepted when it landed; it landed in state Needs Review.Oct 21 2018, 12:43 AM
This revision was automatically updated to reflect the committed changes.